<template>
  <div class="card">
    <Menubar :model="items" />
    <Toast />
  </div>
</template>

<script setup lang="ts">
// Vue
import { ref, onMounted, watch } from "vue";
// Components
import Toast from 'primevue/toast';
import Menubar from 'primevue/menubar';
// Adds js/ts
import { toolbarLang, getTextFromLang } from "@/core/lang";
import { LANG } from '@/core/consts';
import type { Plugin } from "@/core/types";
import { useToast } from "primevue/usetoast";
import plugin from "primevue/toastservice";

//-- PROPS
// const props = defineProps({
//   lang: {
//     type: Number,
//     require: true,
//     default: LANG.EN
//   },
//   plugin: {},
// });
const props = defineProps(['lang', 'plugin']);

//-- EMITS
const emit = defineEmits(['menu-toggle', 'save-project-request', 'close-project', 'config-project', 'plugin-command']);

const items = ref<any>([]);

const lang = ref<LANG>(LANG.EN);

const itemsFixed = [
  {
    label: getTextFromLang(toolbarLang.menu, props.lang),
    icon: 'pi pi-arrow-right-arrow-left',
    command: () => {
      emit('menu-toggle');
    }
  },
  {
    label: getTextFromLang(toolbarLang.save, props.lang),
    icon: 'pi pi-save',
    command: () => {
      emit('save-project-request');
    }
  },
  {
    label: getTextFromLang(toolbarLang.close, props.lang),
    icon: 'pi pi-times',
    command: () => {
      emit('close-project');
    }
  },
  {
    label: getTextFromLang(toolbarLang.config, props.lang),
    icon: 'pi pi-cog',
    command: () => {
      emit('config-project');
    }
  }
]

// const updateItems = (plugin: any) => {
//   if (plugin != undefined) {
//     const itemsPlugin = plugin.getItemsToolBarOfPlugin(props.lang);
//     if (itemsPlugin != undefined && itemsPlugin.length > 0) {
//       let itemsPluginFormated = [];
//       for (let index = 0; index < itemsPlugin.length; index++) {
//         itemsPluginFormated.push(
//           {
//             label: itemsPlugin[index].label,
//             icon: itemsPlugin[index].icon,
//             command: () => {
//               emit('plugin-command', itemsPlugin[index].commandId);
//             }
//           }
//         )
//       }
//       // Concatenar items
//       items.value = [...itemsFixed, ...itemsPluginFormated];
//     } else {
//       items.value = itemsFixed;
//     }
//   } else {
//     items.value = itemsFixed;
//   }
// }

function updateItems(items: { label: string, icon: string, command: any, items: any }[]) {
  for (let index = 0; index < items.length; index++) {
    // El elemnto a evaluar es un arreglo de items?
    if (Array.isArray(items[index].items)) {
      updateItems(items[index].items)
    } else {
      const commandId = items[index].command;
      items[index].command = function command() { emit("plugin-command", commandId) }
    }
  }
  return items;
}

/** Función que ajusta las acciones del plugin */
const updateToolbarItems = (plugin: any) => {
  if (plugin != undefined) {
    let itemsPlugin = plugin.getItemsToolBarOfPlugin(props.lang);
    if (itemsPlugin != undefined && itemsPlugin.length > 0) {
      itemsPlugin = updateItems(itemsPlugin);
      // Concatenar items
      items.value = [...itemsFixed, ...itemsPlugin];
    } else {
      items.value = itemsFixed;
    }
  } else {
    items.value = itemsFixed;
  }
}

// const updateToolbarItems = (plugin: any) => {
//   if (plugin != undefined) {
//     const itemsPlugin = plugin.getItemsToolBarOfPlugin(props.lang);
//     if (itemsPlugin != undefined && itemsPlugin.length > 0) {
//       for (let index = 0; index < itemsPlugin.length; index++) {
//         // El elemnto a evaluar es un arreglo de items?
//         if (Array.isArray(itemsPlugin[index].items)) { } else {
//           const commandId = itemsPlugin[index].command;
//           itemsPlugin[index].command = function command() { emit("plugin-command", commandId) }
//         }
//       }
//       // Concatenar items
//       items.value = [...itemsFixed, ...itemsPlugin];
//     } else {
//       items.value = itemsFixed;
//     }
//   } else {
//     items.value = itemsFixed;
//   }
// }

//-- WATCHERS --
watch(() => props.plugin, (plugin) => {
  // Actualizar items
  updateToolbarItems(plugin);
});

watch(() => props.lang, () => {
  lang.value = props.lang;
})

onMounted(() => {
  items.value = itemsFixed;
})

</script>
